/*
 * Copyright (c) 2012-2015 Andes Technology Corporation
 * All rights reserved.
 *
 */

/*
 * Config the features of startup demo programs.
 */

#ifndef __CONFIG_H__
#define __CONFIG_H__

#ifndef CFG_MAKEFILE
//----------------------------------------------------------------------------------------------------

// Users can configure the defines in this area
// to match different environment setting

//#define CFG_AE100      // platform is AE100
//#define CFG_AE3XX      // platform is AE3XX
//#define CFG_AE210P     // platform is AE210P
#define CFG_AG101P     // platform is AG101P

//#define CFG_PFM      // The time is come from performance monitor.
#define CFG_TIMER    // The time is come from Timer Counter.

#define CFG_LLINIT              // do low level init
#define CFG_CPYDATA             // do data section copying
//----------------------------------------------------------------------------------------------------
#endif


#define GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)

// GCC < 4.8.2 (Before BSP400 gcc version)
// Check the GCC version for toolchain builtin macro compatible issue.
#if GCC_VERSION < 40802

#ifdef NDS32_BASELINE_V3
#define __NDS32_ISA_V3__	NDS32_BASELINE_V3
#endif

#ifdef NDS32_BASELINE_V3M
#define __NDS32_ISA_V3M__	NDS32_BASELINE_V3M
#endif

#endif

#ifndef __ASSEMBLER__

#include <nds32_intrinsic.h>

#ifndef __nds32__mtsr_isb
#define __nds32__mtsr_isb(val, srname)  \
do {__nds32__mtsr(val, srname);__nds32__isb();} while(0)
#endif

#ifndef __nds32__mtsr_dsb
#define __nds32__mtsr_dsb(val, srname)	\
do {__nds32__mtsr(val, srname);__nds32__dsb();} while(0)
#endif

#endif

#ifdef  __NDS32_ISA_V3M__
    #define CFG_16MB            1   // Use 24 bit address mode
#endif

#if defined(CFG_AE210P)
#include "Andes/ae210p.h"
#elif defined(CFG_AE100)
#include "Andes/ae100.h"
#elif defined(CFG_AE3XX)
#include "Andes/ae3xx.h"
#else
#include "Andes/ag101p.h"
#endif

#define SIMULATION               0               // Turn on simulation mode
#define CPU_MHz             (CPUFREQ / MHz)     // CPU speed, should be matched with the board or the setting of SID
#define PCLK_MHZ            (PCLKFREQ / MHz)    // PClk speed in MHZ
#ifndef CFG_AE100
    #define USE_DLM                  1             //For AG101P/AE210P/AE3XX, DLM can be used for data sections
                                                   //For AE100 that dosen't have DLM, MEM is used for data sections without any SW initialization.
#endif
#define MALLOC_SIZE             200                // the reserved memory for malloc()


#ifdef	__NDS32_ISA_V3M__
    // for N6/N7/N8
    #define ENABLE_LOOPCACHE    1
#else // the CPU cores besides N6/N7/N8
    #define __NDS32_STRCMP__    1   // use the STRING ISA for strcmp() function in assembly, it's not supported by AG102.
    #ifndef CFG_AE100
        #ifndef USE_DLM
            #define ENABLE_CACHE        1   // enable I/D cache if I/D cache is available
            #define WRITE_BACK_CACHE    1   // Use write back mode for cache
                                            // The write through will be used if WRITE_BACK_CACHE is not defined
        #endif // USE_DLM
    #endif //CFG_AE100
#endif // __NDS32_ISA_V3M__

#define TIME                    1   // The time of Whetstone is based on library function of time()
#define PLATFORM_TIMER          1   // Use the timer/pfm of AG101P/AE210P/AE3XX/AE100 to measure time

#ifndef __NDS32_EXT_FPU_DP__
    #define atan atanf
    #define sin nds_sinf
    #define cos nds_cosf
    #define sqrt sqrtf
    #define exp nds_expf
    #define log nds_logf
#endif

#endif // __CONFIG_H__
